// JavaScript for PasswordSecurityChecker.kon
// Created/revised by:	Will Holden	1/1/2006

function isSpecial(strChar){
  // Check if parameter passed is a special character.

  // Declare variables.
  var blnIsSpecial = false;
  var numChar=strChar.charCodeAt(0);

  switch(true){
    case (numChar >= 33 && numChar <= 47):
      blnIsSpecial = true;
      break;
    case (numChar >= 58 && numChar <= 64):
      blnIsSpecial = true;
      break;
    case (numChar >= 91 && numChar <= 96):
      blnIsSpecial = true;
      break;
    case (numChar >= 123 && numChar <= 126):
      blnIsSpecial = true;
      break;
  } // switch()

  return blnIsSpecial;
} // fuction isSpecial()        


function isUpper(strChar){
  // Check if parameter passed is an uppercase letter.

  // Declare variables.
  var blnIsUpper = false;
  var numChar = strChar.charCodeAt(0);

  if (numChar >= 65 && (numChar <= 90)){
    blnIsUpper = true;
  } // end if

  return blnIsUpper;
} // function isUpper()


function isLower(strChar){
  // Check if parameter passed is a lowercase letter.

  // Declare variables.
  var blnIsLower = false;
  var numChar = strChar.charCodeAt(0);

  if (numChar >= 97 && (numChar <= 122)){
    blnIsLower = true;
  } // end if

  return blnIsLower;
} // function isLower()


function isNumber(strChar){
  // Check if parameter passed is a number.

  // Declare variables.
  var blnIsNumber = false;
  var numChar = strChar.charCodeAt(0);

  if (numChar >= 48 && (numChar <= 57)){
    blnIsNumber = true;
  } // end if

  return blnIsNumber;
} // function isNumber()


function securityLevel(strPassword){
  // Check if secure qualities are present in passed parameter.

  // Declare variables.
  var intLevel = 0;
  var blnLengthGood = false;
  var blnSpecialPresent = false;
  var blnUpperPresent = false;
  var blnLowerPresent = false;
  var blnNumberPresent = false;

  if (strPassword.length >= 7){
    blnLengthGood = true;
  } // end if

  if (strPassword.length > 0){
    // Cycle through the password one letter at a time.
    for (var i = 0; i <= (strPassword.length - 1); i++){

      // Declare variable.
      var strChar = strPassword.charAt(i);

      switch(true){
        case (isSpecial(strChar)):
          blnSpecialPresent = true;
          break;
        case (isUpper(strChar)):
          blnUpperPresent = true;
          break;
        case (isLower(strChar)):
          blnLowerPresent = true;
          break;
        case (isNumber(strChar)):
          blnNumberPresent = true;
          break;
      } // switch()
    } // loop
  } // end if
  
  if (blnLengthGood){
    intLevel = intLevel + 1;
  } // end if

  if (blnSpecialPresent){
    intLevel = intLevel + 1;
  } // end if

  if (blnUpperPresent){
    intLevel = intLevel + 1;
  } // end if

  if (blnLowerPresent){
    intLevel = intLevel + 1;
  } // end if

  if (blnNumberPresent){
    intLevel = intLevel + 1;
  } // end if

  return intLevel;
} // function securityLevel()


function getSecurity(){
  // Get security level and display security of password.

  // Declare variable.
  var intSecurity = securityLevel(password.data);

  switch(true){
    case (intSecurity == 0):
      alert("Please enter a password.");
      break;
    case (intSecurity == 1):
      securityLevel1.visible = true;
      securityLevel2.visible = false;        
      securityLevel3.visible = false;
      securityLevel4.visible = false;
      securityLevel5.visible = false;
      break;
    case (intSecurity == 2):
      securityLevel1.visible = false;
      securityLevel2.visible = true;        
      securityLevel3.visible = false;
      securityLevel4.visible = false;
      securityLevel5.visible = false;
      break;
    case (intSecurity == 3):
      securityLevel1.visible = false;
      securityLevel2.visible = false;        
      securityLevel3.visible = true;
      securityLevel4.visible = false;
      securityLevel5.visible = false;
      break;
    case (intSecurity == 4):
      securityLevel1.visible = false;
      securityLevel2.visible = false;        
      securityLevel3.visible = false;
      securityLevel4.visible = true;
      securityLevel5.visible = false;
      break;
    case (intSecurity == 5):
      securityLevel1.visible = false;
      securityLevel2.visible = false;        
      securityLevel3.visible = false;
      securityLevel4.visible = false;
      securityLevel5.visible = true;
      break;
  } // switch()
} // function getSecurity()

function textareaSecure(strCheckbox){
  var blnSecure = false;
  if (strCheckbox == "1"){
    blnSecure = true;
  } // end if

  return blnSecure;
} // function textareaSecure()

function updateBehavior(){
  password.secure = textareaSecure(preferences.textareaSecurePref.value);
} // function updateBehavior()